function [SE,ME] = stema(coord,H,B,E,NU,RHO)
SL = [ 1,-1;-1, 1];
ML = [ 2, 1; 1, 2];
X2M1 = coord(2,:) - coord(1,:);
L = sqrt(sum(X2M1.^2));
C = X2M1/L;

L1 = sqrt(sum(C(1,1:2).^2));
if abs(L1) >= 1e-12
  C(2,1) = -C(1,2) / L1;
  C(2,2) =  C(1,1) / L1;
else
  C(2,1) = 0;
  C(2,2) = 1;  
end
C(2,3) = 0;
C(3,1) = -C(1,3) * C(2,2);
C(3,2) =  C(1,3) * C(2,1);
C(3,3) =  C(1,1) * C(2,2) - C(1,2) * C(2,1);

A = H * B;
if (H < B)
  Q = B / H;
  B1 = H;
else
  Q = H / B;
  B1 = B;
end

%ETA2 = (1-192/(pi^5*Q)*tanh(pi/2*Q))/3;
ETA2 = ((2.370592 * Q - 2.486211) * Q + 0.862518)/ ...
       ((7.111777 * Q - 3.057824) * Q + 1);
IT = ETA2 * A * B1 * B1;
IP = A * (H * H + B * B) / 12;

SE = zeros(12);
ME = zeros(12);
SE([1,7],[1,7])   = E * A / L * [ 1,-1;-1, 1];
ME([1,7],[1,7])   = RHO * A * L / 6 * [ 2, 1; 1, 2];
SE([4,10],[4,10]) = E * IT /(2*(1+NU)*L) * [ 1,-1;-1, 1];
ME([4,10],[4,10]) = RHO * IP * L / 6 * [ 2, 1; 1, 2];

SE([2,8,6,12],[2,8,6,12]) = E * A * B * B / (6*L^3) ...
   * [[6,-6;-6,6],L*[-3,-3;3,3];L*[-3,3;-3,3],L*L*[2,1;1,2]];
ME([2,8,6,12],[2,8,6,12]) = RHO * A * L / 4200 ...
   * [[156,54;54,156],L*[-22,13;-13,22];L*[-22,-13;13,22],L*L*[4,-3;-3,4]];
SE([3,9,5,11],[3,9,5,11]) = E * A * H * H / (6*L^3) ...
   * [[6,-6;-6,6],L*[3,3;-3,-3];L*[3,-3;3,-3],L*L*[2,1;1,2]];
ME([3,9,5,11],[3,9,5,11]) = RHO * A * L / 4200  ...
   * [[156,54;54,156],L*[22,-13;13,-22];L*[22,13;-13,-22],L*L*[4,-3;-3,4]];

for IH=1:2
  for JH=1:2
    ID = 6 * IH - 5;
    JD = 6 * JH - 5;
    % case 'false'
    for I = 1:3
      S(I) = SE(ID+I-1,JD+I-1);
      M(I) = ME(ID+I-1,JD+I-1);
    end
    for I=1:3
      for J=1:3
        SS = 0;
        SM = 0;
        for K=1:3
          SS = SS + C(K,I) * C(K,J) * S(K);
          SM = SM + C(K,I) * C(K,J) * M(K);
        end
        SE(ID+I-1,JD+J-1) = SS;
        SM(ID+I-1,JD+J-1) = SM;
      end
    end
    % case 'true'
    ID = ID + 3;
    JD = JD + 3;
    for I = 1:3
      S(I) = SE(ID+I-1,JD+I-1);
      M(I) = ME(ID+I-1,JD+I-1);
    end
    for I=1:3
      for j=1:3
        SS = 0;
        SM = 0;
        for K=1:3
          SS = SS + C(K,I) * C(K,J) * S(K);
          SM = SM + C(K,I) * C(K,J) * M(K);
        end
        SE(ID+I-1,JD+J-1) = SS;
        SM(ID+I-1,JD+J-1) = SM;
      end
    end
    ID = ID -3;
    S32 = SE(ID+2,JD+1);
    S23 = SE(ID+1,JD+2);
    M32 = ME(ID+2,JD+1);
    M23 = ME(ID+1,JD+2);
    for I=1:3
      II = ID +I-1;
      for J=1:3
        JJ = JD + J-1;
        SE(II,JJ) = C(3,I) * C(2,J) * S32 + C(2,I) * C(3,J) * S23;
        ME(II,JJ) = C(3,I) * C(2,J) * M32 + C(2,I) * C(3,J) * M23;
      end
    end
    ID = ID + 3;
    JD = JD - 3;
    S32 = SE(ID+2,JD+1);
    S23 = SE(ID+1,JD+2);
    M32 = ME(ID+2,JD+1);
    M23 = ME(ID+1,JD+2);
    for I=1:3
      II = ID +I-1;
      for J=1:3
        JJ = JD + J-1;
        SE(II,JJ) = C(3,I) * C(2,J) * S32 + C(2,I) * C(3,J) * S23;
        ME(II,JJ) = C(3,I) * C(2,J) * M32 + C(2,I) * C(3,J) * M23;
      end
    end
  end
end